﻿Public Class frm_ampel2
    Dim Interval As Integer
    Dim Zaehler As Integer
    Dim Zyklen As Integer
    Dim Betrieb_Ein As Boolean
    Dim GruenPhase As Integer
    Dim NachtBetrieb As Boolean
    Dim BlinkerOnOff As Boolean
    Dim Betriebsphase As String
    Dim Anlage_Ein As Boolean

#Region "ListOfPctureBoxes"
    Private AmpelLED As List(Of PictureBox) = Nothing
    Private Sub PrepareLeds()
        AmpelLED = New List(Of PictureBox) From {PictureBox0, PictureBox1, PictureBox2, PictureBox3, PictureBox4, PictureBox5, PictureBox6, PictureBox7, PictureBox8, PictureBox9, PictureBox10, PictureBox11}
    End Sub

    Private AmpelPhasen As List(Of String) = Nothing
    Private Sub Ampelzyklen()
        AmpelPhasen = New List(Of String) From {"Aus", "HSRotGelb", "HSGrün", "HSGelb", "Reaum", "NSRotGelb", "NSGrün", "NSGelb", "NSRot"}
    End Sub

    Private SteuerLED As List(Of PictureBox) = Nothing
    Private Sub PrepareSteuerLeds()
        SteuerLED = New List(Of PictureBox) From {PB_betrieb, PB_nacht, PB_onoff, PB_Taktung}
    End Sub
    Private Sub ResetSteuerLed()
        SteuerLED.ForEach(Sub(x) x.BackColor = Color.Green)
    End Sub
    Private Sub ResetLedLights()
        AmpelLED.ForEach(Sub(x) x.BackColor = Color.DimGray)
    End Sub
    Private Sub Combosfuellen()
        For I = 0 To 23
            Dim Zeiten = Date.Today.AddHours(I).ToString("HH:mm")
            CmB_Starttime.Items.Add(Zeiten)
            Cmb_Endtime.Items.Add(Zeiten)
        Next
        CB_nachtbetrieb.Checked = True
        CmB_Starttime.SelectedItem = "22:00"
        Cmb_Endtime.SelectedItem = "06:00"
    End Sub
#End Region


#Region "Steuerung"
    Private Sub frm_SPS_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        btn_betrieb.Enabled = False : Combosfuellen()
        Ampelzyklen() : Anlagegestoppt() : PrepareLeds() : PrepareSteuerLeds() : ResetLedLights() : ResetSteuerLed()
    End Sub

    Private Sub ControlsDisabeln()
        CmB_Starttime.Enabled = False
        Cmb_Endtime.Enabled = False
        CB_nachtbetrieb.Enabled = False
        NuUpDo_Gruenphase.Enabled = False
    End Sub

    Private Sub ControlsEnabeln()
        CmB_Starttime.Enabled = True
        Cmb_Endtime.Enabled = True
        CB_nachtbetrieb.Enabled = True
        NuUpDo_Gruenphase.Enabled = True
    End Sub

    Private Sub btn_anlage_Click(sender As Object, e As EventArgs) Handles btn_anlage.Click
        If Not Anlage_Ein Then
            PB_onoff.BackColor = Color.Lime
            If CB_nachtbetrieb.Checked Then PB_nacht.BackColor = Color.Lime
            btn_anlage.Text = "Anlage aus"
            Anlage_Ein = True
            btn_betrieb.Enabled = True
        Else
            PB_onoff.BackColor = Color.Green
            btn_anlage.Text = "Anlage ein"
            Anlage_Ein = False
            btn_betrieb.Enabled = False
            Anlage_aus()
        End If
    End Sub

    Private Sub btn_betrieb_Click(sender As Object, e As EventArgs) Handles btn_betrieb.Click
        If Not Betrieb_Ein Then
            PB_betrieb.BackColor = Color.Lime
            btn_betrieb.Text = "Ampel stoppen"
            ControlsDisabeln()
            Anlagegestartet()
        Else
            PB_betrieb.BackColor = Color.Green
            btn_betrieb.Text = "Ampel starten"
            Betrieb_Ein = False
            ControlsEnabeln()
        End If
    End Sub

    Private Sub anzeigen()
        lbl_zaehler.Text = "Zähler: " & Zaehler.ToString
        lbl_zyklus.Text = "Zyklen: " & Zyklen.ToString
        lbl_phasen.Text = "Ampelphase: " & AmpelPhasen(Zyklen)
        lbl_betrieb.Text = "Betriebsphase: " & Betriebsphase
    End Sub

    Private Sub Anlage_aus()
        Zaehler = 0 : Zyklen = 0 : Interval = 0
        anzeigen() : ResetLedLights() : ResetSteuerLed() : Timer_Steuerung.Stop() : lbl_zeit.Text = "00:00:00"
    End Sub

    Private Sub Anlagegestoppt()
        Zaehler = 0 : Zyklen = 0 : Interval = 0
        anzeigen()
    End Sub

    Private Sub Anlagegestartet()
        Zaehler = 0 : Zyklen = 0 : Interval = 1
        Betrieb_Ein = True
        anzeigen()
    End Sub

    Private Sub NuUpDo_Gruenphase_ValueChanged(sender As Object, e As EventArgs) Handles NuUpDo_Gruenphase.ValueChanged
        GruenPhase = CInt(NuUpDo_Gruenphase.Value)
    End Sub
#End Region

#Region "TaktTimer"
    Function IsInTime(ByVal StartTimestamp As String, ByVal EndTimestamp As String) As Boolean
        Dim StartTime, EndTime, RefTime As DateTime
        RefTime = DateTime.Now
        If DateTime.TryParse(StartTimestamp, StartTime) AndAlso DateTime.TryParse(EndTimestamp, EndTime) Then
            If StartTime > EndTime Then
                If RefTime > StartTime Then EndTime = EndTime.AddDays(1) Else StartTime = StartTime.AddDays(-1)
            End If
            Return RefTime >= StartTime AndAlso RefTime <= EndTime
        End If
        Return False
    End Function

    Private Sub Timer_Steuerung_Tick(sender As Object, e As EventArgs) Handles Timer_Steuerung.Tick
        lbl_zeit.Text = DateTime.Now.ToLongTimeString
        ResetLedLights()
        If Not Betrieb_Ein Then
            Anlagegestoppt()
        ElseIf IsInTime(CStr(CmB_Starttime.SelectedItem), CStr(Cmb_Endtime.SelectedItem)) AndAlso CB_nachtbetrieb.Checked Then
            BlinkerOnOff = Not BlinkerOnOff
            Me.Nachtbetriebwechsel(PB_Taktung, Color.Yellow, Color.Orange)
            Betriebsphase = "Nachtphase"
            phaseNacht()
            anzeigen()
            Return
        ElseIf AmpelPhasen(Zyklen) = "HSRotGelb" Then
            Interval = CInt(GruenPhase / 2)
            phaseRotGelbHS()
        ElseIf AmpelPhasen(Zyklen) = "HSGrün" Then
            Interval = GruenPhase
            phaseGrünHS()
        ElseIf AmpelPhasen(Zyklen) = "HSGelb" Then
            Interval = CInt(GruenPhase / 2) - 1
            phaseGelbHS()
        ElseIf AmpelPhasen(Zyklen) = "Reaum" Then
            Interval = 1
            phaseRotNS()
        ElseIf AmpelPhasen(Zyklen) = "NSRotGelb" Then
            Interval = CInt(GruenPhase / 2) - 1
            phaseRotGelbNS()
        ElseIf AmpelPhasen(Zyklen) = "NSGrün" Then
            Interval = CInt(GruenPhase / 2) + 1
            phaseGrünNS()
        ElseIf AmpelPhasen(Zyklen) = "NSGelb" Then
            Interval = CInt(GruenPhase / 2)
            phaseGelbNS()
        ElseIf AmpelPhasen(Zyklen) = "NSRot" Then
            Interval = 1
            phaseRotNS()
        End If
        Zaehler = Zaehler + 1
        If Zaehler = Interval Then Zyklen = Zyklen + 1 : Zaehler = 0
        If Zyklen = AmpelPhasen.Count Then Zaehler = 1 : Zyklen = 1
        Betriebsphase = "Tagphase"
        anzeigen()
    End Sub
#End Region

#Region "Ampelphasenausgaben"
    Private Sub phaseRotGelbHS()
        AmpelLED(0).BackColor = Color.Red
        AmpelLED(3).BackColor = Color.Red
        AmpelLED(6).BackColor = Color.Red
        AmpelLED(9).BackColor = Color.Red
        AmpelLED(1).BackColor = Color.Yellow
        AmpelLED(4).BackColor = Color.Yellow
    End Sub
    Private Sub phaseGrünHS()
        AmpelLED(2).BackColor = Color.Lime
        AmpelLED(5).BackColor = Color.Lime
        AmpelLED(6).BackColor = Color.Red
        AmpelLED(9).BackColor = Color.Red
    End Sub
    Private Sub phaseGelbHS()
        AmpelLED(1).BackColor = Color.Yellow
        AmpelLED(4).BackColor = Color.Yellow
        AmpelLED(6).BackColor = Color.Red
        AmpelLED(9).BackColor = Color.Red
    End Sub
    Private Sub phaseRotNS()
        AmpelLED(0).BackColor = Color.Red
        AmpelLED(3).BackColor = Color.Red
        AmpelLED(6).BackColor = Color.Red
        AmpelLED(9).BackColor = Color.Red
    End Sub
    Private Sub phaseRotGelbNS()
        AmpelLED(0).BackColor = Color.Red
        AmpelLED(3).BackColor = Color.Red
        AmpelLED(6).BackColor = Color.Red
        AmpelLED(9).BackColor = Color.Red
        AmpelLED(7).BackColor = Color.Yellow
        AmpelLED(10).BackColor = Color.Yellow
    End Sub
    Private Sub phaseGrünNS()
        AmpelLED(8).BackColor = Color.Lime
        AmpelLED(11).BackColor = Color.Lime
        AmpelLED(0).BackColor = Color.Red
        AmpelLED(3).BackColor = Color.Red
    End Sub
    Private Sub phaseGelbNS()
        AmpelLED(7).BackColor = Color.Yellow
        AmpelLED(10).BackColor = Color.Yellow
        AmpelLED(0).BackColor = Color.Red
        AmpelLED(3).BackColor = Color.Red
    End Sub
#End Region

#Region "Nachtbetrieb"
    Private Sub CB_nachtbetrieb_CheckedChanged(sender As Object, e As EventArgs) Handles CB_nachtbetrieb.CheckedChanged
        Nachtbetriebsmodus()
    End Sub
    Private Sub Nachtbetriebsmodus()
        If CB_nachtbetrieb.Checked Then
            NachtBetrieb = True
            PB_nacht.BackColor = Color.Lime
            Betriebsphase = "Nachtphase"
        Else
            PB_nacht.BackColor = Color.Green
            Betriebsphase = "24Std.Phase"
            NachtBetrieb = False
        End If
    End Sub
    Private Sub Nachtbetriebwechsel(PB_Taktung As Control, color1 As Color, color2 As Color)
        If BlinkerOnOff Then PB_Taktung.BackColor = color1 Else PB_Taktung.BackColor = color2
    End Sub
    Private Sub phaseNacht()
        If BlinkerOnOff Then
            AmpelLED(1).BackColor = Color.Yellow
            AmpelLED(4).BackColor = Color.Yellow
            AmpelLED(7).BackColor = Color.Yellow
            AmpelLED(10).BackColor = Color.Yellow
        End If
    End Sub
#End Region

End Class